import java.util.*;

/** This class can be used to test your implementation of the 
 *  ClientDatabase class
 */
public class DatabaseTester
{
  public static void main(String[] args)
  {
    Scanner in = new Scanner(System.in);
    
    DatabaseInterface db = DataFactory.makeDatabase();
    
    System.out.println("Enter a command: insert, remove, lookup, or exit: ");
    String cmd = in.nextLine();
    while(!cmd.equalsIgnoreCase("exit"))
    {
      if (cmd.equalsIgnoreCase("insert"))
      {
        testInsert(db, in);
      } else if (cmd.equalsIgnoreCase("remove"))
      {
        testRemove(db, in);
      } else if (cmd.equalsIgnoreCase("lookup"))
      {
        testLookup(db, in);
      }
      
      System.out.println("Database: --------------------------------");
      System.out.println(db.toString());
      System.out.println("------------------------------------------");
      
      System.out.println("Enter a command: insert, remove, lookup, or exit: ");
      cmd = in.nextLine();  
    }
    in.close();

  }
  
  /* A helper method that can be used to test inserting values into the 
   * database
   */
  private static void testInsert(DatabaseInterface db, Scanner in)
  {
    System.out.println("Enter email address: ");
    String email = in.nextLine();
    System.out.println("Enter first name: ");
    String firstName = in.nextLine();
    System.out.println("Enter last name: ");
    String lastName = in.nextLine();
    System.out.println("Enter company name: ");
    String companyName = in.nextLine();
    
    db.insert(new ClientInfo(email, firstName, lastName, companyName));
  }
  
  /* A helper method that can be used to test removing values from the 
   * database
   */
  private static void testRemove(DatabaseInterface db, Scanner in)
  {
    System.out.println("Enter email address: ");
    String keyID = in.nextLine();
    
    db.remove(new ClientID(keyID));
  }
  
  /* A helper method that can be used to test looking up values in the 
   * database
   */
  private static void testLookup(DatabaseInterface db, Scanner in)
  {
    System.out.println("Enter email address: ");
    String keyID = in.nextLine();
    
    db.lookup(new ClientID(keyID));   
  }

}
